/*
  engine.cpp
  Gets and parses html-page

  Copyright (c) 2004 Joni Valtanen 
  licensed under GNU General Public License. See COPYING for details. 

  See the README and COPYING for detailed licences.
*/

#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <string.h>


#include "engine.h"


char *yksikko(char *m);
short int isValid(char *m);

/* Get values, place, clock, date and some testing*/
char *value[10], *paikka, *klo, *pvm, *testi;
/*Get value names*/
char *valname[10];

/* buffers */
char bf[1000] = "";
char bf2[7][1000] = {"","","","","","",""};


/*
  void haeSaa(char *pk)
  Gets and Parses http-page.

  INPUT: pointer to city name city
  OUT: -
*/  
void haeSaa(char *pk)
{
  int sock;
  char base[] = "GET /saa/paikalli.html\?kunta=%s\r\n\r\n HTTP/1.0\r\n\r\n";
  char name[] = "www.ilmatieteenlaitos.fi";
  int j,i,n,k,l; 
  short int hit=FALSE;
  struct sockaddr_in sa;
  struct hostent *he;

  /* save city (pk) to request*/
  sprintf(bf,base,pk); 

  for(i=0;i<10;i++)
    valname[i]=NULL;

  /* tcp inits */
  sock = socket( PF_INET, SOCK_STREAM, 0 );

  sa.sin_family = AF_INET;
  sa.sin_port = htons( 80 );

  he = gethostbyname( name );
  bcopy((char *)he->h_addr, 
         (char *)&sa.sin_addr.s_addr,
         he->h_length);

  connect( sock, (struct sockaddr *)&sa, sizeof(sa) );

  send( sock, bf, strlen(bf), 0 );
	
  i=0;
  j=0;
  k=0;
  l=0;
  while ((n = recv( sock, bf, 999, 0 )) > 0)
    {
      bf[n] = 0;

      for(i=0;  i<n; i++)
      {
	if(bf[i] == '\n')
	{
	  bf2[j][k] = 0;
      
	  testi = &bf2[j][0];

	  if(!hit)
	    {
	      for(l=0; bf2[j][l] != ' ' && l<=k; l++ );
	      if(bf2[j][l] == ' ')
		{
		  bf2[j][l]= 0;
		  paikka = &bf2[j][++l];
		}
	      if(!strcmp(testi,"\n<B>Havaintoasema:") || !strcmp(testi,"\n<B>S&auml;&auml;"))
		{
		  if(!strcmp(testi,"\n<B>S&auml;&auml;"))
		    {
		      for(; bf2[j][l] != ':' && l<=k; l++ );
		      l++;
		      if(bf2[j][l] == ' ')
			{
			  bf2[j][l]= 0;
			  paikka = &bf2[j][++l];
			}
		      
		    }
		  j++;
		  hit = TRUE;
		}
	    }
	  if(j>0)
	    j++;
	  if(j>6)
	    j=6;
	  k=0;
	} 
	bf2[j][k++]=bf[i];
      }


    }

  close( sock );

  /* place */
  i=0;
  k=1;
  for(i=0; paikka[i] != '<'; i++);
  paikka[i] = 0;

  #ifdef DEBUG
    printf("%s\n",paikka);
  #endif

  testi = &bf2[k][0];
  for(i=0; bf2[k][i] != ' '; i++);
  bf2[k][i] = 0;
  if(strcmp(testi,"\nTuorein"))
    k++;
  

  /* time */
  for(i=0; bf2[k][i] != '>'; i++);
  i++;
  for(; bf2[k][i] != '>'; i++);
  i++;
  pvm = &bf2[k][i]; /* date */
  for(; bf2[k][i] != ' '; i++);
  bf2[k][i] = 0;

  klo = &bf2[k][++i]; /* clock */
  for(; bf2[k][i] != '<'; i++);
  bf2[k][i] = 0;

  i = 2;
  j=0;
  k++;

  while( 1 )
  {
    /* get magnitude */
    valname[j] = &bf2[k][i];
    for(; bf2[k][i] != '&'; i++)
      if(bf2[k][i] == 0)
	break;
    
    bf2[k][i] = 0;
    i++;
    if(bf2[k][i] == 0)
      break;
  #ifdef DEBUG
        printf("#%s#\n",valname[j]);
  #endif
    /* get value to magnitude */
    for(; bf2[k][i] != '>'; i++)
      if(bf2[k][i] == 0)
	break;
    i++;
    if(bf2[k][i] == 0)
      break;

    value[j] = &bf2[k][i];

    /* Espoo is different :P*/
    if(!strcmp(valname[j],"l"))
    {
      for(; bf2[k][i] != '&'; i++)
	if(bf2[k][i] == 0)
	  break;
      for(; bf2[k][i] != '&'; i++)
       if(bf2[k][i] == 0)
	 break;
      strcpy(valname[j],"lmptila");
    }
    for(; bf2[k][i] != '&'; i++)
      if(bf2[k][i] == 0)
	break;

    bf2[k][i] = 0;
    i++;
    for(; bf2[k][i] != '>'; i++)
      if(bf2[k][i] == 0)
	break;

    /* if something comes after 'sademr' */
    if(!strcmp(valname[j],"sademr"))
      {
	for(; bf2[k][i] != ' '; i++)
	  if(bf2[k][i] == 0)
	    break;
	i--;
      }

    /* let's see is magnitude ok */
    if(isValid(valname[j]))
      j++;
    else
	valname[j] = NULL;
    i++;
    if(bf2[k][i] == 0)
      break;
    i++;
    if(bf2[k][i] == 0)
      break;

 
  }

  
  if((valname[j] != NULL) && !isValid(valname[j]))
    valname[j] = NULL;

  for(i=0; valname[i]!=NULL; i++)
  {
    /* remove </B> from cloudy  'pilvisyys' */
    for(j=0; value[i][j] != '<' && value[i][j] != 0; j++);
      value[i][j] = 0;

  }

}

/*
  char *yksikko(char *m)
  Gets unit from magnitude

  INPUT: pointer to magnitude
  OUT: pinter to unit
*/
char *yksikko(char *m)
{
  if(!strcmp(m,"kosteus"))
     return "%";
  if(!strcmp(m,"lmptila"))
     return "C";
  if(!strcmp(m,"sademr"))
     return "mm/h";
  if(!strcmp(m,"pilvisyys"))
     return "";
  if(!strcmp(m,"paine"))
     return "hPa";
  else
     return "m/s";
}

/*
  short int isValid(char *m)
  Return true if inputword is knnown. Used by parser.

  input: pointer to input word
  out: boolean

*/
short int isValid(char *m)
{
  if(!strcmp(m,"kosteus"))
     return TRUE;
  if(!strcmp(m,"lmptila"))
     return TRUE;
  if(!strcmp(m,"sademr"))
     return TRUE;
  if(!strcmp(m,"paine"))
     return TRUE;
  if(!strcmp(m,"pilvisyys"))
     return TRUE;
  if(!strcmp(m,"pohjoistuulta"))
     return TRUE;
  if(!strcmp(m,"eteltuulta"))
     return TRUE;
  if(!strcmp(m,"ittuulta"))
     return TRUE;
  if(!strcmp(m,"lnsituulta"))
     return TRUE;
  if(!strcmp(m,"lounaistuulta"))
     return TRUE;
  if(!strcmp(m,"kaakkoistuulta"))
     return TRUE;
  if(!strcmp(m,"koillistuulta"))
     return TRUE;
  if(!strcmp(m,"luoteistuulta"))
     return TRUE;
  if(!strcmp(m,"tyynt"))
     return TRUE;
  
  return FALSE;

}
