/*
   wmfw.c
 
  In enlish:
    wmfw shows weather from chosen finnish city in WindowMaker-dockapp from www.ilmatieteenlaitos.fi.

    This application uses docklib-0.4(libdock 0.4) and requires it for compilation. 
    Maeby docklib-0.2 is suitable too. Texts are in finnish so I thing it's not usable like this 
    for people who are not finnish, but it's possible to make your own. Take parts from here 
    and make your own wmXX.
  
  SUOMEKSI:
    WindowMaker-dockapp suomalaisille kaupungeille ilmatieteenlaistoksen-webbi sivuilta.
    wmfw nytt tietyilt halutuilta paikkakunnista lmptilan, kosteus prosentin jne.,
    mit nyt sattuu mittaus paikasta lytymn.

    Ohjelma kytt docklib-0.4(libdock 0.4) ja knnettess vaati sen asennettuna.
    Epilen ett ohjelma kntyy mys docklib-0.2:n avulla. Katso README-tiedosto ohjelman 
    kytt koskeviin ohjeisiin ja COPYING-tiedosto lisenssisseihin.

  Copyright (c) 2004 Joni Valtanen 
    licensed under GNU General Public License. See COPYING for details. 

  Copyright (c) 1999 Alfredo K. Kojima
    Parts of the program are from docklib-0.2 example. ( basic structure )

  Copyright (c) 1999  Sam Hawker
    font_init()-function and other font related stuff from wmmount ( Yes I'm lazy )   

  See the README and COPYING for detailed licences.

*/


#include <dockapp.h>
#include <unistd.h>
#include <math.h>
#include <string.h>

#include "engine.h"

#define WMFONT "-*-fixed-medium-r-*-*-8-*-*-*-*-*-*-*"

extern char *value[10], *paikka, *klo, *pvm, *testi;
extern char *valname[10];
extern char bf[1000];
extern char bf2[7][1000];

char *wmfont=NULL;
Font fname;
int fx,fy;

GC gc;
Pixmap pixmap;
char buf[20][50];

time_t updateTime=0; /* seconds */
int waitTime = 30; /* minutes */

short scr=0;
short lines=0;

char *displayName = "";
char *cityName = "";

static DAProgramOption options[] = {
  {"-time", NULL, "update time in minutes", DOInteger, False, {&waitTime}}, 
  {"-city", NULL, "city of Finland to display", DOString, False, {&cityName}},
    {"-display", NULL, "display to use", DOString, False, {&displayName}}
};

void buttonrelease(XButtonEvent *xev);
void buttonpress(XButtonEvent *xev);
void font_init(void);
void setTimes(void);

void firstscr(void);
void otherscr(void);
void secondscr(void);
void thirdscr(void);


/*
  int main...
*/
int main(int argc, char *argv[])
{
   
    int i,j,k;

    DAParseArguments(argc, argv, options,
		     sizeof(options)/sizeof(DAProgramOption),
		     "WMFW dockapp", "WMFW 0.5");

    DAInitialize(displayName, "WMFW", 58, 58, argc, argv);
    pixmap = DAMakePixmap();
    gc = DefaultGC(DADisplay, DefaultScreen(DADisplay));
    font_init();

    XSetFont(DADisplay, gc, fname);

    DAShow();

    while (1) {
	XEvent ev;
	i = j = k = 0;

	if(( updateTime - time(NULL) < 0))
	{

	  haeSaa(cityName);
	  setTimes();

	sprintf(buf[k++], "%s", paikka);
	sprintf(buf[k++], "%s", pvm);
	sprintf(buf[k++], "%s", klo);

	for(i=0; valname[i]!=NULL; i++)
	  {
  #ifdef DEBUG
	    printf("%s\n",valname[i]);
  #endif
	    //ainakin pilvisyydest pois </B>
	    for(j=0; value[i][j] != '<' && value[i][j] != 0; j++);
	    value[i][j] = 0;
	    sprintf(buf[k++], "%s:",valname[i] );
	    sprintf(buf[k++], "%s %s",value[i],yksikko(valname[i]) );
	  }
        lines = i*2;

	}

	XSetForeground(DADisplay, gc, 
		       BlackPixel(DADisplay, DefaultScreen(DADisplay)));
	XFillRectangle(DADisplay, pixmap, gc, 0, 0, 58, 58);

	XSetForeground(DADisplay, gc, 
		       WhitePixel(DADisplay, DefaultScreen(DADisplay)));

	if(scr == 0)
	  firstscr();
	else
	  otherscr();

	DASetPixmap(pixmap);

         XSelectInput(DADisplay, DAWindow, ButtonPressMask | ButtonReleaseMask | ExposureMask);
	/* handle all pending X events */
	while (XPending(DADisplay)) {
	    XNextEvent(DADisplay, &ev);
      switch(ev.type) {
      case ButtonPress:
        buttonpress(&ev.xbutton);
	break;
      case ButtonRelease:
	buttonrelease(&ev.xbutton);
	break;}
	    DAProcessEvent(&ev);
	}

	usleep(10000);
    }
  return 0;
}

/*
  void buttonrelease(XButtonEvent *xev)

*/
void buttonrelease(XButtonEvent *xev)
{

  short pages=0;

  if( (lines-2)%4 )
    pages = (lines-2)/4 + 1;
  else
    pages = (lines-2)/4;
 
  scr++;
  if(scr > pages)
    scr=0;
	XSetForeground(DADisplay, gc, 
		       BlackPixel(DADisplay, DefaultScreen(DADisplay)));
	XFillRectangle(DADisplay, pixmap, gc, 0, 0, 58, 58);

	XSetForeground(DADisplay, gc, 
		       WhitePixel(DADisplay, DefaultScreen(DADisplay)));

	if(scr == 0)
	  firstscr();
	else
	  otherscr();

}

/*
  void buttonpress(XButtonEvent *xev)

*/
void buttonpress(XButtonEvent *xev)
{

 
}

/*
  void firstscr(void)
  draws first screen

  INPUT: -
  OUT:	-
*/
void firstscr(void)
{
  int i;

	for(i=0; i<3; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, ((1+i)*(10)), buf[i], strlen(buf[i]));
	for(i=3; i<5; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, (45+((i-3)*10)), buf[i], strlen(buf[i]));
}

/*
  void otherscr(void)
  draw other screen ??? i don't remember

  INPUT: -
  OUT:	-
*/
void otherscr(void)
{
  int i;

  /*scr=1 bufferlines 5-8 to draw*/
  /*scr=2 9-12 to draw*/

  /* Draw text to dock */
  XDrawString(DADisplay, pixmap, gc, 1, 10, buf[0], strlen(buf[0]));
  for(i=1; i<5; i++)
   XDrawString(DADisplay, pixmap, gc, 1, (((i)*(10))+15), buf[scr*4+i], strlen(buf[scr*4+i]));
}

/*
  void secondscr(void)
  draws second screen

  INPUT: -
  OUT:	-
*/
void secondscr(void)
{
  int i;


        XDrawString(DADisplay, pixmap, gc, 1, 10, buf[0], strlen(buf[0]));

	for(i=5; i<9; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, (((i-6)*(10))+35), buf[i], strlen(buf[i]));
}

/*
  void thirdscr(void)
  draws third screen

  INPUT: -
  OUT:	-
*/
void thirdscr(void)
{
  int i;

        XDrawString(DADisplay, pixmap, gc, 1, 10, buf[0], strlen(buf[0]));

	for(i=9; i<13; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, (((i-9)*(10))+25), buf[i], strlen(buf[i]));
}

/*
  void font_init(void)
  inits fonts

  INPUT: -
  OUT: -
*/
void font_init(void)
{
 /* Initialize fonts
   */
  XFontStruct *xfs;
  char *font;

  font=wmfont;
  if(font==NULL)
    font=WMFONT;
  xfs=XLoadQueryFont(DADisplay, WMFONT);
  
  fname=xfs->fid;
  fx=6-xfs->min_bounds.lbearing;
  fy+=xfs->ascent;
  XFreeFontInfo(NULL, xfs, 1);

}

/*
  void setTimes(void)
  Set updatetime in seconds

  INPUT: -
  OUT: -
*/
void setTimes(void)
{
  updateTime = time(NULL)+(60*waitTime);
}
